package mn.spikes;

import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

public class ChainedServlet extends HttpServlet {

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		String innerUrl = System.getProperty("inner.url");
		if (innerUrl == null || innerUrl.length() == 0) {
			throw new ServletException("inner.url is empty");
		}

		RequestConfig.Builder configBuilder = RequestConfig.custom().setSocketTimeout(30000);
		HttpClientBuilder clientBuilder = HttpClientBuilder.create().setDefaultRequestConfig(configBuilder.build());

		CloseableHttpClient httpClient = clientBuilder.build();
		try {
			HttpGet httpGet = new HttpGet(innerUrl + req.getQueryString());
			CloseableHttpResponse response = httpClient.execute(httpGet);
			String responseBody = EntityUtils.toString(response.getEntity());
			resp.getWriter().println(responseBody);
		} finally {
			httpClient.close();
		}
	}
}
